#! /usr/bin/env python

# Copyright (C) 2005  Jean-Claude Rimbault & Optiman
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from pythonite.context import register_ext
from pythonite.objects.file_obj import File

class CalendarEvent:
    date = ''
    end = ''
    key = ''
    summary = ''

class Calendar(File):
    objtype = 'calendar'
    def __init__(self, path, context):
        File.__init__(self, path, context)
        prefix, suffix = os.path.splitext(path)
        self.path = prefix + '.ics'
	self.parse(self.path)
    def __len__(self):
        return len(self.events)
    def __getitem__(self, num):
        return self.events[num]
    def parse(self, path):
        inside = 0
	last = ''
	self.events = []
        for line in open(path).readlines():
	    line = line.strip()
	    if not line:
	        continue
	    if ':' not in line:
	        last = line
		continue
	    elif last:
	        line = last + line
		last = ''
	    if line == 'BEGIN:VEVENT':
	        inside = 1
		event = CalendarEvent()
		self.events.append(event)
	    elif line == 'END:VEVENT':
	        inside = 0
	    elif inside:
		key, val = line.split(':', 1)     
		if key == 'SUMMARY':
		    event.summary = val
		    event.key = event.summary.split()[0]
		elif key == 'DTSTART' or key == 'DTSTART;VALUE=DATE':
		    event.date = val
		elif key == 'DTEND' or key == 'DTEND;VALUE=DATE':
		    event.end = val

register_ext('.ics', Calendar)
